/***************************************************************************
                          monk_ai.cpp  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "monk_ai.h"
#include "resources.h"
#include "monk.h"
#include "map_sample.h"
#include "map.h"
#include "maptile.h"
#include "player.h"
#include "timer.h"
#include "game.h"


Monk_Ai::Monk_Ai(Monk* _monk, Map_Sample* _sample)
{
sample=_sample;
monk=_monk;
right=left=up=down=0;
old_x=monk->get_x();
old_y=monk->get_y();
hang=false;
timer=new Timer;
hp1=hp2=false;
}
Monk_Ai::~Monk_Ai()
{
}
void Monk_Ai::act()
{
	up=down=right=left=false;


	if(old_y==monk->get_y() && old_x==monk->get_x() && !(monk->move_hleft() || monk->move_hright()))
	{
		hang=true;
		timer->reset();
	}
	else
	{
		//who's the next sacrifice? :)
		if(sample->p2) /* 2 player mode ? */
		{
			if((sample->p2->is_hunted()==false && sample->p1->is_hunted()==true) || (sample->p1->is_hunted() && distance(monk->get_x(), monk->get_y(), sample->p1->get_x(), sample->p1->get_y()) <= distance(monk->get_x(), monk->get_y(), sample->p2->get_x(), sample->p2->get_y())))
			{
				if(monk->move_up() && sample->p1->get_y()<monk->get_y())
				up=true;
				else if(monk->move_down() && sample->p1->get_y()>monk->get_y())
				down=true;
				else if(monk->move_left() && sample->p1->get_x()<monk->get_x())
				left=true;
				else if(monk->move_right() && sample->p1->get_x()>monk->get_x())
				right=true;

				hp1=true;
				hp2=false;
			}
			else if(sample->p2->is_hunted()==true)
			{
				if(monk->move_up() && sample->p2->get_y()<monk->get_y())
				up=true;
				else if(monk->move_down() && sample->p2->get_y()>monk->get_y())
				down=true;
				else if(monk->move_left() && sample->p2->get_x()<monk->get_x())
				left=true;
				else if(monk->move_right() && sample->p2->get_x()>monk->get_x())
				right=true;

				hp1=false;
				hp2=true;
			}
		}
		else
		{
			if(sample->p1->is_hunted())
			{
				if(monk->move_up() && sample->p1->get_y()<monk->get_y())
				up=true;
				else if(monk->move_down() && sample->p1->get_y()>monk->get_y())
				down=true;
				else if(monk->move_left() && sample->p1->get_x()<monk->get_x())
				left=true;
				else if(monk->move_right() && sample->p1->get_x()>monk->get_x())
				right=true;

				hp1=true;
				hp2=false;
			}
		}
	}

	if(hang)
	{
		if(monk->move_up())
		{
			up=true;
		}
		else if(monk->move_down())
		{
			down=true;
		}
		else if(monk->move_left())
		{
			left=true;
		}
		else if(monk->move_right())
		{
			right=true;
		}

		if(timer->time_elapsed()>=3.0f)
		hang=false;	
	}

	if(monk->move_hleft() || monk->move_hright())
	{
		if(hp1) {
			if(monk->move_hleft() && monk->get_x() > sample->p1->get_x())
			{
				left=true;
				right=up=down=false;
			}
			else if(monk->move_hright() && monk->get_x() < sample->p1->get_x())
			{
				right=true;
				left=up=down=false;
			}
		}

		if (hp2) {
			if(monk->move_hleft() && monk->get_x() > sample->p2->get_x())
			{
				left=true;
				right=up=down=false;
			}
			else if(monk->move_hright() && monk->get_x() < sample->p2->get_x())
			{
				right=true;
				left=up=down=false;
			}
		}
	}

  //debug keyz :)
  /*	if(CL_Keyboard::get_keycode(CL_KEY_ENTER))
	{
		cout<<" "<<monk->move_up()<<" "<<endl;
		cout<<monk->move_left()<<"M"<<monk->move_right()<<endl;
		cout<<" "<<monk->move_down()<<" "<<endl;
    cout<<"left: "<<left<<endl;
    cout<<"right: "<<right<<endl;
    cout<<"up: "<<up<<endl;
    cout<<"down: "<<down<<endl;
	}
	if(CL_Keyboard::get_keycode(CL_KEY_LEFT))
	left=true;
	if(CL_Keyboard::get_keycode(CL_KEY_UP))
	up=true;
	if(CL_Keyboard::get_keycode(CL_KEY_RIGHT))
	right=true;
	if(CL_Keyboard::get_keycode(CL_KEY_DOWN))
	down=true;
	if(CL_Keyboard::get_keycode(CL_KEY_BACKSPACE))
	monk->die();
  //end debug keyz*/

	//remember oldpos;
	old_y=monk->get_y();
	old_x=monk->get_x();
}
bool Monk_Ai::is_left()
{
	return left;
}
bool Monk_Ai::is_right()
{
	return right;
}
bool Monk_Ai::is_up()
{
	return up;
}
bool Monk_Ai::is_down()
{
	return down;
}